4 USAGE='<fetch-options> <repository> <refspec>...'
7 set_reflog_action "fetch $*"
8 cd_to_toplevel ;# probably unnecessary...
11 _x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
12 _x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
28 test -t 1 || no_progress=--no-progress
33 -a|--a|--ap|--app|--appe|--appen|--append)
36 --upl|--uplo|--uploa|--upload|--upload-|--upload-p|\
37 --upload-pa|--upload-pac|--upload-pack)
39 exec="--upload-pack=$1"
41 --upl=*|--uplo=*|--uploa=*|--upload=*|\
42 --upload-=*|--upload-p=*|--upload-pa=*|--upload-pac=*|--upload-pack=*)
43 exec=--upload-pack=$(expr "z$1" : 'z-[^=]*=\(.*\)')
46 -f|--f|--fo|--for|--forc|--force)
49 -t|--t|--ta|--tag|--tags)
52 -n|--n|--no|--no-|--no-t|--no-ta|--no-tag|--no-tags)
55 -u|--u|--up|--upd|--upda|--updat|--update|--update-|--update-h|\
56 --update-he|--update-hea|--update-head|--update-head-|\
57 --update-head-o|--update-head-ok)
60 -q|--q|--qu|--qui|--quie|--quiet)
66 -k|--k|--ke|--kee|--keep)
70 shallow_depth="--depth=`expr "z$1" : 'z-[^=]*=\(.*\)'`"
74 shallow_depth="--depth=$1"
88 origin=$(get_default_remote)
89 test -n "$(get_remote_url ${origin})" ||
90 die "Where do you want to fetch from today?"
91 set x $origin ; shift ;;
96 # No command line override and we have configuration for the remote.
97 exec="--upload-pack=$(get_uploadpack $1)"
101 remote=$(get_remote_url "$@")
104 rsync_slurped_objects=
106 if test "" = "$append"
108 : >"$GIT_DIR/FETCH_HEAD"
111 # Global that is reused later
112 ls_remote_result=$(git ls-remote $exec "$remote") ||
113 die "Cannot get the repository state from $remote"
115 append_fetch_head () {
117 test -n "$verbose" && flags="$flags$LF-v"
118 test -n "$force$single_force" && flags="$flags$LF-f"
119 GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION" \
120 git fetch--tool $flags append-fetch-head "$@"
123 # updating the current HEAD with git-fetch in a bare
124 # repository is always fine.
125 if test -z "$update_head_ok" && test $(is_bare_repository) = false
127 orig_head=$(git rev-parse --verify HEAD 2>/dev/null)
130 # Allow --notags from remote.$1.tagopt
131 case "$tags$no_tags" in
133 case "$(git config --get "remote.$1.tagopt")" in
139 # If --tags (and later --heads or --all) is specified, then we are
140 # not talking about defaults stored in Pull: line of remotes or
141 # branches file, and just fetch those and refspecs explicitly given.
142 # Otherwise we do what we always did.
144 reflist=$(get_remote_refs_for_fetch "$@")
148 echo "$ls_remote_result" |
149 git show-ref --exclude-existing=refs/tags/ |
152 echo ".${name}:${name}"
156 # remote URL plus explicit refspecs; we need to merge them.
157 reflist="$reflist$LF$taglist"
159 # No explicit refspecs; fetch tags only.
164 fetch_all_at_once () {
166 eval=$(echo "$1" | git fetch--tool parse-reflist "-")
169 ( : subshell because we muck with IFS
172 if test "$remote" = . ; then
173 git show-ref $rref || echo failed "$remote"
174 elif test -f "$remote" ; then
175 test -n "$shallow_depth" &&
176 die "shallow clone with bundle is not supported"
177 git bundle unbundle "$remote" $rref ||
178 echo failed "$remote"
180 if test -d "$remote" &&
182 # The remote might be our alternate. With
183 # this optimization we will bypass fetch-pack
184 # altogether, which means we cannot be doing
185 # the shallow stuff at all.
186 test ! -f "$GIT_DIR/shallow" &&
187 test -z "$shallow_depth" &&
189 # See if all of what we are going to fetch are
190 # connected to our repository's tips, in which
191 # case we do not have to do any fetch.
192 theirs=$(echo "$ls_remote_result" | \
193 git fetch--tool -s pick-rref "$rref" "-") &&
195 # This will barf when $theirs reach an object that
196 # we do not have in our repository. Otherwise,
197 # we already have everything the fetch would bring in.
198 git rev-list --objects $theirs --not --all \
199 >/dev/null 2>/dev/null
201 echo "$ls_remote_result" | \
202 git fetch--tool pick-rref "$rref" "-"
210 git-fetch-pack --thin $exec $keep $shallow_depth \
211 $quiet $no_progress $flags "$remote" $rref ||
212 echo failed "$remote"
218 test -n "$verbose" && flags="$flags -v"
219 test -n "$force" && flags="$flags -f"
220 GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION" \
221 git fetch--tool $flags native-store \
222 "$remote" "$remote_nick" "$refs"
237 # These are relative path from $GIT_DIR, typically starting at refs/
239 if expr "z$ref" : 'z\.' >/dev/null
242 ref=$(expr "z$ref" : 'z\.\(.*\)')
246 if expr "z$ref" : 'z+' >/dev/null
249 ref=$(expr "z$ref" : 'z+\(.*\)')
253 remote_name=$(expr "z$ref" : 'z\([^:]*\):')
254 local_name=$(expr "z$ref" : 'z[^:]*:\(.*\)')
256 rref="$rref$LF$remote_name"
258 # There are transports that can fetch only one head at a time...
260 http://* | https://* | ftp://*)
261 test -n "$shallow_depth" &&
262 die "shallow clone with http not supported"
263 proto=`expr "$remote" : '\([^:]*\):'`
264 if [ -n "$GIT_SSL_NO_VERIFY" ]; then
267 if [ -n "$GIT_CURL_FTP_NO_EPSV" -o \
268 "`git config --bool http.noEPSV`" = true ]; then
269 noepsv_opt="--disable-epsv"
272 # Find $remote_name from ls-remote output.
273 head=$(echo "$ls_remote_result" | \
274 git fetch--tool -s pick-rref "$remote_name" "-")
275 expr "z$head" : "z$_x40\$" >/dev/null ||
276 die "No such ref $remote_name at $remote"
277 echo >&2 "Fetching $remote_name from $remote using $proto"
278 case "$quiet" in '') v=-v ;; *) v= ;; esac
279 git-http-fetch $v -a "$head" "$remote" || exit
282 test -n "$shallow_depth" &&
283 die "shallow clone with rsync not supported"
284 TMP_HEAD="$GIT_DIR/TMP_HEAD"
285 rsync -L -q "$remote/$remote_name" "$TMP_HEAD" || exit 1
286 head=$(git rev-parse --verify TMP_HEAD)
288 case "$quiet" in '') v=-v ;; *) v= ;; esac
289 test "$rsync_slurped_objects" || {
290 rsync -a $v --ignore-existing --exclude info \
291 "$remote/objects/" "$GIT_OBJECT_DIRECTORY/" || exit
293 # Look at objects/info/alternates for rsync -- http will
294 # support it natively and git native ones will do it on
295 # the remote end. Not having that file is not a crime.
296 rsync -q "$remote/objects/info/alternates" \
297 "$GIT_DIR/TMP_ALT" 2>/dev/null ||
298 rm -f "$GIT_DIR/TMP_ALT"
299 if test -f "$GIT_DIR/TMP_ALT"
301 resolve_alternates "$remote" <"$GIT_DIR/TMP_ALT" |
304 case "$alt" in 'bad alternate: '*) die "$alt";; esac
305 echo >&2 "Getting alternate: $alt"
306 rsync -av --ignore-existing --exclude info \
307 "$alt" "$GIT_OBJECT_DIRECTORY/" || exit
309 rm -f "$GIT_DIR/TMP_ALT"
311 rsync_slurped_objects=t
316 append_fetch_head "$head" "$remote" \
317 "$remote_name" "$remote_nick" "$local_name" "$not_for_merge" || exit
325 http://* | https://* | ftp://* | rsync://* )
329 fetch_all_at_once "$@"
334 fetch_main "$reflist" || exit
336 # automated tag following
337 case "$no_tags$tags" in
341 # effective only when we are following remote branch
342 # using local tracking branch.
344 echo "$ls_remote_result" |
345 git show-ref --exclude-existing=refs/tags/ |
348 git cat-file -t "$sha1" >/dev/null 2>&1 || continue
349 echo >&2 "Auto-following $name"
350 echo ".${name}:${name}"
356 # do not deepen a shallow tree when following tags
358 fetch_main "$taglist" || exit ;;
362 # If the original head was empty (i.e. no "master" yet), or
363 # if we were told not to worry, we do not have to check.
368 curr_head=$(git rev-parse --verify HEAD 2>/dev/null)
369 if test "$curr_head" != "$orig_head"
372 -m "$GIT_REFLOG_ACTION: Undoing incorrectly fetched HEAD." \
374 die "Cannot fetch into the current branch."